package com.persagy.modules.tool.dal.dataobject.codegen;

import com.baomidou.mybatisplus.annotation.TableName;
import com.persagy.framework.mybatis.core.dataobject.BaseDO;
import com.persagy.modules.tool.enums.codegen.ToolCodegenTemplateTypeEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * 代码生成 table 表定义
 *
 * @author
 */
@TableName(value = "tool_codegen_table", autoResultMap = true)
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = true)
public class ToolCodegenTableDO extends BaseDO {

    /**
     * ID 编号
     */
    private Long id;

    /**
     * 导入类型
     * <p>
     * 枚举 {@link ToolCodegenTemplateTypeEnum}
     */
    private Integer importType;

    // ========== 表相关字段 ==========

    /**
     * 表名称
     */
    private String tableName;
    /**
     * 表描述
     */
    private String tableComment;
    /**
     * 备注
     */
    private String remark;

    // ========== 类相关字段 ==========

    /**
     * 模块名，即一级目录
     * <p>
     * 例如说，system、infra、tool 等等
     */
    private String moduleName;
    /**
     * 业务名，即二级目录
     * <p>
     * 例如说，user、permission、dict 等等
     */
    private String businessName;
    /**
     * 类名称（首字母大写）
     * <p>
     * 例如说，SysUser、SysMenu、SysDictData 等等
     */
    private String className;
    /**
     * 类描述
     */
    private String classComment;
    /**
     * 作者
     */
    private String author;

    // ========== 生成相关字段 ==========

    /**
     * 模板类型
     * <p>
     * 枚举 {@link ToolCodegenTemplateTypeEnum}
     */
    private Integer templateType;

    // ========== 菜单相关字段 ==========

    /**
     * 父菜单编号
     */
    private Long parentMenuId;

}
